<?php
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');
 
jimport('joomla.form.formfield');
 
// The class name must always be the same as the filename (in camel case)
class JFormFieldPicklist extends JFormFieldList {

    //The field class must know its own type through the variable $type.
    protected $type = 'list';

    

    public function getOptions() {
            // code that returns HTML that will be shown as the form field
        $options = array ();
		$picklist_type = (string)$this->element['picklist'];
		if(!in_array($picklist_type,array('accounts','costheadings','invoicetemplates'))) return false;
		$db = JFactory::getDBO();
		

		$db->setQuery("SELECT params FROM #__modules WHERE module = 'mod_virtuemart_acumulus' LIMIT 1");
		$params = $db->loadResult();
		if($params == null) return false;

		
		$params = new JParameter($params);
		if(strlen($params->get('acumulus_code','')) < 2) return false;

		$url_params = '?format=json&';
		$url_params .= 'contractcode='.urlencode($params->get('acumulus_code','')).'&';
		$url_params .= 'username='.urlencode($params->get('acumulus_username','')).'&';
		$url_params .= 'password='.urlencode($params->get('acumulus_password',''));

		$url = 'https://www.sielsystems.nl/acumulus/api/picklist_'.$picklist_type.'.php'.$url_params;
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		$response = curl_exec($ch);
		curl_close($ch);

		if(strlen($response) < 20) return false;

		$parsed_response = json_decode($response);

		

		switch($picklist_type) {
			case 'accounts':
				if(isset($parsed_response->account) && is_array($parsed_response->account)) {
					foreach($parsed_response->account as $account) {
						
						$options[] = JHTML::_('select.option', $account->accountnumber, $account->accountnumber .' ('.(is_string($account->accountdescription) ? $account->accountdescription : '').')');
					}
				}
			break;

			case 'costheadings':

				if(isset($parsed_response->costheading) && is_array($parsed_response->costheading)) {
					foreach($parsed_response->costheading as $costheading) {
						
						$options[] = JHTML::_('select.option', $costheading->costheadingid, $costheading->costheadingname);
					}
				}
			break;


			case 'invoicetemplates':
				if(isset($parsed_response->invoicetemplate) && is_array($parsed_response->invoicetemplate)) {
					foreach($parsed_response->invoicetemplate as $invoicetemplate) {
						
						$options[] = JHTML::_('select.option', $invoicetemplate->invoicetemplateid, $invoicetemplate->invoicetemplatename .' ('.(!is_array($invoicetemplate->invoicetemplateid) ? $invoicetemplate->invoicetemplateid : '').')');
					}
				}
			break;
		}

		return $options;
    }
}